﻿<?php
// $Id: finder.form.inc,v 1.1.2.2 2009/03/23 09:20:55 danielb Exp $

/**
 * @file
 * The finder form.
 */

/**
 * Function to create finder form.
 */
function finder_form(&$form_state, $finder) {

  $form_state['storage']['finder'] = $finder;
  $form = array();
  $form['#action'] = url($finder->path);
  $form['finder_form'] = array(
    '#weight' => 0,
    '#prefix' => '<div class="finder-form finder-'. $finder->finder_id .'">',
    '#suffix' => '</div>',
  );
  $form['finder_form']['#prefix'] .= $finder->settings['form']['prefix'] ? '<div class="prefix">'. $finder->settings['form']['prefix'] .'</div>' : '';
  $max_weight = 0;
  foreach ($finder->elements as $element) {
    $max_weight = max($max_weight, $element->weight);
    if (isset($form_state['values'][$element->finder_element_id])) {
      $element_default = $form_state['values'][$element->finder_element_id];
    }
    else {
      $element_default = $element->settings['form']['default_value'];
    }
    $form['finder_form'][$element->finder_element_id] = array(
      '#title' => $element->title,
      '#weight' => $element->weight,
      '#description' => $element->description,
      '#prefix' => $element->settings['form']['prefix'],
      '#suffix' => $element->settings['form']['suffix'],
      '#default_value' => $element_default,
      '#required' => $element->settings['form']['required'],
    );
    $module = &$element->element_handler['#module'];
    $handler_function = $module .'_finder_element';
    $handler_function($element, $form['finder_form'][$element->finder_element_id]);
  }
  $form['finder_form']['submit'] = array(
    '#type' => 'submit',
    '#value' => $element->settings['form']['button_text'],
    '#weight' => $max_weight + 1000,
  );
  $form['finder_form']['#suffix'] = ($element->settings['form']['suffix'] ? '<div class="suffix">'. $element->settings['form']['suffix'] .'</div>' : '') . $form['finder_form']['#suffix'];

  return $form;
}

/**
 * Validate function for finder form.
 */
function finder_form_validate($form, &$form_state) {

}

/**
 * Submit function for finder form.
 */
function finder_form_submit($form, &$form_state) {
  $form_state['storage']['values'] = $form_state['values'];
  finder_form_state($form_state);
}

/**
 * Helper function for finder form to pass form state to results page.
 */
function finder_form_state($form_state = NULL) {
  static $finder_form_state = NULL;
  if ($form_state) {
    $finder_form_state = $form_state;
  }
  elseif (isset($_GET['finder'])) {
    $finder_form_state = $_SESSION['finder'][$_GET['finder']];
  }
  return $finder_form_state;
}